# ************************************************************
# @(#) web/webserver/cgi/Core/Admin/web_config.pm web_r3.6.2.3.1:cset.001111:22:33@(#)
#
# Filename    : web/webserver/cgi/Core/Admin/web_config.pm
#
# *************************************************************
#
#                   COPYRIGHT NOTICE
#
# This file remains the intellectual property of:
#
#                       Vallent
#                    Spencer House
#                    23 Sheen Road
#                 Richmond, Surrey, UK
#
# Copyright (c) 2005 Vallent Software Systems UK. All rights reserved.
#
# **************************************************************
#
#   Description : user/group configuration module
#
# ************************************************************
use strict;
use Data::Dumper;

package Core::Admin::web_config;
use vars qw(@ISA);

@ISA = qw(Exporter);
use Data::Dumper;

# set up logging
require "$ENV{'NPRWEB_DIR'}/cgi/Lib/Logger.pm";
my $logger = new Logger( $ENV{NPRWEB_NPR_LOGFILE}, $ENV{NPRWEB_NPR_LOGLEVEL} );

my $alert;

my %decode_char = (
	'%26'	=> "\&",
	'%3A'	=> "\:",
	'%40'	=> "\@",
	'%2B' => "\+",
	'%2F'	=> "\/",
	'%20'	=> " ",
	'%24'	=> "\$",
	'%21' => "\!",
	'%28' => "\(",
	'%29' => "\)",
	'%5B' => "\[",
	'%5D' => "\]",
);

sub new {
	my $proto = shift;    # get the class name
	my $class = ref($proto) || $proto;
	    
	my $this = {
		WEBCONFIGSH => $ENV{NPRWEB_NPR_DIR}."/webconfig.sh",
		WEBCONFIGHASH => {},
		@_
	}; 
	
	bless ($this, $class);
		
	return $this ;
}

#################################################################################
#
# Function    : _configWEB
# Parameters  : 
# Description : 
# Returns     :
# Called By   :  web_config.htm
#
##################################################################################
sub _configWEB {
	my $this = shift;
	_writeLog("IN: _configWEB");
		
	$this->_buildPage();
}

##################################################################################
#
# Function    : _buildPage 
# Parameters  : 
# Description : 
# Returns     :
# Called By   :  
#
##################################################################################
sub _buildPage{
	my $this = shift;
	_writeLog("IN: _buildPage");
	
	$this->_readWebconfig();
	
	if ($this->{MW_system}{WEBC_PROCESS} eq "UPDATE") {
		$this->_applyConfig();
		_writeLog("DO PROCESSING TO UPDATE webconfig.sh ");
		$this->_writeWebconfig();
	}
	
	my $html = "";

	$html .= qq[
			<HEAD><TITLE>Configure Metrica/WEB Behaviour</TITLE>
			<LINK REL="stylesheet" HREF="/css/style.css" TYPE="text/css">
		<link rel="stylesheet" type="text/css" href="/css/tabs.css">
			</HEAD>
	    <p align=center class="bluehead0">Configure Metrica/WEB Behaviour<hr></p>
	];
	
	$html .= $this->_displaySetting();
		
	 return $html;
};

##################################################################################
#
# Function    : _displaySetting 
# Parameters  : 
# Description : 
# Returns     :
# Called By   :  
#
##################################################################################
sub _displaySetting{
	my $this = shift;
	
	$this->_readWebconfig();
	#_writeLog(Dumper($this->{WEBCONFIGHASH}));
	
	my $display = qq[
		<FORM name="webconfig_web" action=$this->{MW_system}{CGIPROG} target="Main" method="GET">
		<table cellspacing=0>
			<tr>
				<td class="tableblueboxes">&nbsp Location of logfile&nbsp</td><td>&nbsp</td>
				<td>];
				
	$display .= _useInput("CFG_NPRWEB_NPR_LOGFILE",$this->{WEBCONFIGHASH}{NPRWEB_NPR_LOGFILE},$this->{WEBCONFIGHASH}{NPRWEB_NPR_LOGFILE});
				
	$display .= qq[
				</td>
			</tr><tr>
				<td class="tableblueboxes">&nbsp Log Level&nbsp</td><td>&nbsp</td>
				<td>];
				
	$display .= _useoption("CFG_NPRWEB_NPR_LOGLEVEL",{
												0 => "No logs",
												1 => "Panic",
												2 => "Error",
												3 => "Warning",
												4 => "Info",
											},$this->{WEBCONFIGHASH}{NPRWEB_NPR_LOGLEVEL}
	);
				
	$display .= qq[</td>
			</tr><tr>
				<td class="tableblueboxes">&nbsp Buffersize&nbsp</td><td>&nbsp</td>
				<td>];
				
	$display .= _useInput("CFG_BUFFERSIZE",$this->{WEBCONFIGHASH}{BUFFERSIZE},$this->{WEBCONFIGHASH}{BUFFERSIZE});
				
	$display .= qq[</td>
			</tr><tr>
				<td class="tableblueboxes">&nbsp Command to Send Email&nbsp</td><td>&nbsp</td>
				<td>];
				
	$display .= _useInput("CFG_MAIL_COMMAND",$this->{WEBCONFIGHASH}{MAIL_COMMAND},$this->{WEBCONFIGHASH}{MAIL_COMMAND});
				
	$display .= qq[</td>
			</tr><tr>
				<td class="tableblueboxes">&nbsp Support Email Address&nbsp</td><td>&nbsp</td>
				<td>];
				
	$display .= _useInput("CFG_SUPPORT_MAIL",$this->{WEBCONFIGHASH}{SUPPORT_MAIL},$this->{WEBCONFIGHASH}{SUPPORT_MAIL});
				
	$display .= qq[</td>
			</tr><tr>
				<td class="tableblueboxes">&nbsp Command for Image Conversion&nbsp</td><td>&nbsp</td>
				<td>];
				
	$display .= _useInput("CFG_PS2PDF_COMMAND",$this->{WEBCONFIGHASH}{PS2PDF_COMMAND},$this->{WEBCONFIGHASH}{PS2PDF_COMMAND});
				
	$display .= qq[</td>
			</tr><tr>
				<td class="tableblueboxes">&nbsp Image Format for Graphs&nbsp</td><td>&nbsp</td>
				<td>];
				
	$display .= _useoption("CFG_IMAGE_FORMAT",{
												"GIF" => "GIF",
												"PNG" => "PNG",
											},$this->{WEBCONFIGHASH}{IMAGE_FORMAT}
	);
				
	$display .= qq[</td>
			</tr><tr>
				<td class="tableblueboxes">&nbsp Enable Conditional Filtering&nbsp</td><td>&nbsp</td>
				<td>];
				
	$display .= _useoption("CFG_COND_FILTER",{
												"True" => "Allow conditional filtering for Element List",
												"False" => "Do not use conditional filtering",
											},$this->{WEBCONFIGHASH}{COND_FILTER}
	);
	
	$display .= qq[</td>
                        </tr><tr>
                                <td class="tableblueboxes">&nbsp Element Suggestion&nbsp</td><td>&nbsp</td>
                               <td>];
        $display .= _useoption("CFG_ELEMENT_SUGGESTION",{
			"True" => "Enable element suggestion",
                        "False" => "Disable element suggestion"
			},$this->{WEBCONFIGHASH}{ELEMENT_SUGGESTION}
	);
				
	$display .= qq[</td>
			</tr><tr>
				<td class="tableblueboxes">&nbsp Path to Image Alchemy&nbsp</td><td>&nbsp</td>
				<td>];
				
	$display .= _useInput("CFG_ALCHEMY_PATH",$this->{WEBCONFIGHASH}{ALCHEMY_PATH},$this->{WEBCONFIGHASH}{ALCHEMY_PATH});
				
	$display .= qq[</td>
			</tr><tr>
				<td class="tableblueboxes">&nbsp Path to Acrobat Distiller&nbsp</td><td>&nbsp</td>
				<td>];
				
	$display .= _useInput("CFG_DISTILLER_PATH",$this->{WEBCONFIGHASH}{DISTILLER_PATH},$this->{WEBCONFIGHASH}{DISTILLER_PATH});
				
	$display .= qq[</td>
			</tr><tr>
				<td class="tableblueboxes">&nbsp Option to Generate Queries/Rules&nbsp</td><td>&nbsp</td>
				<td>];
				
	$display .= _useoption("CFG_GENQR_OPT",{
												"1" => "Based on Primary Keys",
												"2" => "Extended with Non-Primary Keys",
												"3" => "All Keys",
											},$this->{WEBCONFIGHASH}{GENQR_OPT}
	);
				
	$display .= qq[</td>
			</tr><tr>
				<td class="tableblueboxes">&nbsp Local Timezone for Webserver&nbsp</td><td>&nbsp</td>
				<td>];
				
	$display .= _useInput("CFG_TZ",$this->{WEBCONFIGHASH}{TIMEOUT},$this->{WEBCONFIGHASH}{TZ});
				
	$display .= qq[</td>
			</tr><tr>
				<td class="tableblueboxes">&nbsp Timeout for processing request&nbsp</td><td>&nbsp</td>
				<td>];
				
	$display .= _useInput("CFG_WEBRUN_TIMEOUT",$this->{WEBCONFIGHASH}{WEBRUN_TIMEOUT},$this->{WEBCONFIGHASH}{WEBRUN_TIMEOUT});
				
	$display .= qq[</td>
			</tr>
			<tr>
				<td colspan=3 align=center>
				<input type=hidden name=WEBC_PROCESS value="UPDATE">
		    <input type=hidden name=NPRSYS value=$this->{MW_system}{NPRSYS}>
		    <input type=hidden name=NPRTARGET value="/admin/web_config.htm">
					<input name="apply" value="updateweb" type="image" src="/images/buttons/apply.gif" 
					onclick="document.webconfig_web.submit(); return false"/>
				</td>
			</tr>
		</table>
		</FORM>
	];
	
	return $display;
}

##################################################################################
#
# Function    : _readWebconfig
# Parameters  :
# Description :
# Returns     :
# Called By   :
#
##################################################################################
sub _readWebconfig {
	my $this = shift;
	#_writeLog("read from ".$this->{WEBCONFIGSH});
	my $webconfigfile = $this->{WEBCONFIGSH};
	
	open(CONFIGFILE,"<$webconfigfile") || die "Cannot open $webconfigfile";
	while (<CONFIGFILE>) {
		chomp;
		next if(/^#/);
		next if ($_ =~ /^$/);
		next if(/^export/);
		next if(/^PATH/);
		my ($cfgparam,$cfgvalue) = split("=",$_);
		next if (!$cfgparam);
		next if (!$cfgvalue);
		#_writeLog("$cfgparam => $cfgvalue");
		$this->{WEBCONFIGHASH}{$cfgparam} = $cfgvalue;
	}	
	close(CONFIGFILE);
	
	bless $this;
}

##################################################################################
#
# Function    : _applyConfig
# Parameters  :
# Description :
# Returns     :
# Called By   :
#
##################################################################################
sub _applyConfig {
	my $this = shift;
	
	my $querystring = $ENV{QUERY_STRING};
	$querystring =~ s/\+/%20/g;
	
  my @applyConfig =  split ("&",$querystring);
	#_writeLog("PASSED AS : ".Dumper(\@applyConfig));
  
  foreach (@applyConfig) {
	  my ($cfgparam,$cfgvalue) = split("=",$_);
	  if ($cfgparam =~ /^CFG_/) {
		  foreach my $char (keys %decode_char) {
			  $cfgvalue =~ s/$char/$decode_char{$char}/g;
		  }
		  $cfgparam =~ s/^CFG_//;
		  $this->{WEBCONFIGHASH}{$cfgparam} = "$cfgvalue";
		}
  }
  #_writeLog(Dumper(\%{$this->{WEBCONFIGHASH}}));

  return; 
};

##################################################################################
#
# Function    : _writeWebconfig
# Parameters  :
# Description :
# Returns     :
# Called By   :
#
##################################################################################
sub _writeWebconfig {
	my $this = shift;

  my $webconfig = $this->{WEBCONFIGSH};
  
  my $header = "\#!/bin/sh
\#
\# Environment needed for Metrica/Web (assumes that NPR can be run on this
\# machine)
\#
\# Client/server set-up: no
\#
  ";
	
  open (CFGFILE,"> $webconfig") || die "cannot open file 	open $webconfig";
  print CFGFILE $header;
  
  #foreach (keys %{$this->{WEBCONFIGHASH}}) {
	#  my $encodecfg = $this->{WEBCONFIGHASH}{$_};
	#  foreach my $char (keys %decode_char) {
	#	  $encodecfg =~ s/$char/$decode_char{$char}/g;
	#  }
	#  
	#  if ($_ =~ /COMMAND/) {
	#	  print CFGFILE "\n" . $_ . "=" . "\"$encodecfg\"" . "\n";
	#  }else{
  #		print CFGFILE "\n" . $_ . "=$encodecfg\n";
	#	}
  #	print CFGFILE "export " . $_ . "\n";
	#}
	
	print CFGFILE "
\# NPR VERSION
NPR_VER=$this->{WEBCONFIGHASH}{'NPR_VER'}
export NPR_VER

\# WEBSERVER/NPRnum variable
NPRWEB_NPR_DIR=$this->{WEBCONFIGHASH}{'NPRWEB_NPR_DIR'}
export NPRWEB_NPR_DIR

\#NPR Database name
NPR_DB=$this->{WEBCONFIGHASH}{'NPR_DB'}
export NPR_DB

\#NPR Administration Database
NPR_ADMIN_DB=$this->{WEBCONFIGHASH}{'NPR_ADMIN_DB'}
export NPR_ADMIN_DB

\#Our directory
NPRWEB_DIR=$this->{WEBCONFIGHASH}{'NPRWEB_DIR'}
export NPRWEB_DIR

\#NPR server (or client, if necessary) machine
NPR_SERVER=$this->{WEBCONFIGHASH}{'NPR_SERVER'}
export NPR_SERVER

\#main NPR directory
NPR_DIR=$this->{WEBCONFIGHASH}{'NPR_DIR'}
export NPR_DIR
NPR_BIN_DIR=\$NPR_DIR/bin
export NPR_BIN_DIR

\#Path for nprwwwreport, nprwwwpermit, etc.
PATH=\$NPR_BIN_DIR:\$PATH

\#Directory needed by the above programs
NPR_WWW_DIR=$this->{WEBCONFIGHASH}{'NPR_WWW_DIR'}
export NPR_WWW_DIR

\#Path for hardcopy file
KF_HARDCOPY_PATH=$this->{WEBCONFIGHASH}{'KF_HARDCOPY_PATH'}
export KF_HARDCOPY_PATH

\#Environment variable saying whether or PAS is installed
WEB_PAS=$this->{WEBCONFIGHASH}{'WEB_PAS'}
export WEB_PAS

\#Technolgy layer type (i.e TGSM)
WEB_TECH_TYPE=$this->{WEBCONFIGHASH}{'WEB_TECH_TYPE'}
export WEB_TECH_TYPE

\#Hierarchy cache file field separator
NPR_WWW_CACHE_SEPARATOR=$this->{WEBCONFIGHASH}{'NPR_WWW_CACHE_SEPARATOR'}
export NPR_WWW_CACHE_SEPARATOR

\#TQL clients' directory, esp. tsl
TQL_CLIENT_DIR=$this->{WEBCONFIGHASH}{'TQL_CLIENT_DIR'}
export TQL_CLIENT_DIR

\#Setting the path to include TQL_CLIENT_DIR
PATH=\${TQL_CLIENT_DIR}/bin:\$PATH

\#Path for alchemy
ALCHEMY_PATH=$this->{WEBCONFIGHASH}{'ALCHEMY_PATH'}
PATH=\$ALCHEMY_PATH:\$PATH

\#Path for distiller
DISTILLER_PATH=$this->{WEBCONFIGHASH}{'DISTILLER_PATH'}
PATH=\$DISTILLER_PATH:\$PATH

export PATH

\#Number formatting
\#See cgi/FormattedNumber.pm for valid formats
WWW_NUMBER_FORMAT=$this->{WEBCONFIGHASH}{'WWW_NUMBER_FORMAT'}
export WWW_NUMBER_FORMAT

\#Date format options are :
\#'UK' / '%d/%m/%y'
\#'US' / '%m/%d/%y'
\#'YMD' / '%y/%m/%d'
\#'Swedish' / '%y%m%d'

\#Format used in the Web interface :
WWW_DATE_FORMAT=$this->{WEBCONFIGHASH}{'WWW_DATE_FORMAT'}
export WWW_DATE_FORMAT

\#Format used by nprwwwreport,
\#this date format must be of the same type as that used by the tslserver
\#since wwwtslserver uses NPR_DATE_INPUT_FORMAT, 
\#for example, if NPR_DATE_INPUT_FORMAT=%m %d %y then TQL_DATE_FORMAT=US  :
TQL_DATE_FORMAT=$this->{WEBCONFIGHASH}{'TQL_DATE_FORMAT'}
export TQL_DATE_FORMAT
\#Arbitrary formats (using %d, %m and %y) can also be used for this variable.

\#Configure the support administration email address
SUPPORT_MAIL=$this->{WEBCONFIGHASH}{'SUPPORT_MAIL'}
export SUPPORT_MAIL

\#Set defaults for the webserver log file and the webserver log level. These
\#should be used with care as the logfile can grow rapidly
\#
\#	LOGLEVEL 	DESCRIPTION
\#	0		No logs are written
\#	1		Panic
\#	2		Error
\#	3		Warning
\#	4		Info
\#
NPRWEB_NPR_LOGFILE=$this->{WEBCONFIGHASH}{'NPRWEB_NPR_LOGFILE'}
export NPRWEB_NPR_LOGFILE
";

if (! $this->{WEBCONFIGHASH}{'NPRWEB_NPR_LOGLEVEL'}) {
	print CFGFILE "
NPRWEB_NPR_LOGLEVEL=0
export NPRWEB_NPR_LOGLEVEL";
}else{
	print CFGFILE "
NPRWEB_NPR_LOGLEVEL=$this->{WEBCONFIGHASH}{'NPRWEB_NPR_LOGLEVEL'}
export NPRWEB_NPR_LOGLEVEL";
}

print CFGFILE "

\#Set the tsl buffersize here for the perpetual tsl servers and the cache
BUFFERSIZE=$this->{WEBCONFIGHASH}{'BUFFERSIZE'}
export BUFFERSIZE

\#Mailing tool
MAIL_COMMAND=\"$this->{WEBCONFIGHASH}{'MAIL_COMMAND'}\"
export MAIL_COMMAND

\# Create the alchemy command for converting PS to PDF
PS2PDF_COMMAND=\"$this->{WEBCONFIGHASH}{'PS2PDF_COMMAND'}\"
export PS2PDF_COMMAND

\# Set default image format for graph output
\# The image format options are: GIF, PNG
IMAGE_FORMAT=$this->{WEBCONFIGHASH}{'IMAGE_FORMAT'}
export IMAGE_FORMAT

\# Set the local timezone for webserver machine
TZ=$this->{WEBCONFIGHASH}{'TZ'}
export TZ

\# Option for Element List
COND_FILTER=$this->{WEBCONFIGHASH}{'COND_FILTER'}
export COND_FILTER

ELEMENT_SUGGESTION=$this->{WEBCONFIGHASH}{'ELEMENT_SUGGESTION'}
export ELEMENT_SUGGESTION

\# Option to generate cache
\#	OPTION 	DESCRIPTION
\#	1		will create caches/rules based on primary keys only
\#	2		will do option 1 and extended with non-primary keys for those not yet created
\#	3		All Keys (traditional way)
\#
GENQR_OPT=$this->{WEBCONFIGHASH}{GENQR_OPT}
export GENQR_OPT

\# Timeout in second for graphs/report generation
WEBRUN_TIMEOUT=$this->{WEBCONFIGHASH}{WEBRUN_TIMEOUT}
export WEBRUN_TIMEOUT

\# You may need to set-up QYINT as well.
TQL_SERVER_DIR=$this->{WEBCONFIGHASH}{'TQL_SERVER_DIR'}
export TQL_SERVER_DIR
";
	
	close (CFGFILE);

  return; 
};

##################################################################################
#
# Function    : _useInput
# Parameters  :
# Description :
# Returns     :
# Called By   :
#
##################################################################################
sub _useInput {
	my ($name,$val,$default) = @_;
	my $rethtml;
	
	$rethtml = "<input type=text size=70 id=$name name=$name value=$default>";
	
	return $rethtml;
}

##################################################################################
#
# Function    : _useoption
# Parameters  :
# Description :
# Returns     :
# Called By   :
#
##################################################################################
sub _useoption {
	my ($name,$val,$default) = @_;
	my $rethtml;
	
	$rethtml = "<select name=$name>";
	foreach my $key (sort keys %{$val}) {
		if ($key eq $default) {
			$rethtml .= "<option value=$key selected='selected'>$$val{$key}</option>";
		}else{
			$rethtml .= "<option value=$key>$$val{$key}</option>";
		}
	}
	$rethtml .= "</select>";
	
	return $rethtml;
}

##################################################################################
#
# Function    : _writeLog
# Parameters  :
# Description :
# Returns     :
# Called By   :
#
##################################################################################
sub _writeLog {
  my ($tolog) = @_ ;

  #print $tolog."\n";
  $logger->log($tolog, 4);

  return; 
};


1;
