# ************************************************************
# @(#) web/webserver/cgi/Core/CounterBrowsers/Input.pm web_r3.6.2.3.1:cset.001111:22:33@(#)
#
# Filename    : web/webserver/cgi/Core/CounterBrowsers/Input.pm
# *************************************************************
#
#                   COPYRIGHT NOTICE
#
# This file remains the intellectual property of:
#
#                       Vallent
#                    Spencer House
#                    23 Sheen Road
#                 Richmond, Surrey, UK
#
# Copyright (c) 2005 Vallent Software Systems UK. All rights reserved.
#
# **************************************************************
#
#   Description : 
#
# ************************************************************
#
package Core::CounterBrowsers::Input ;

require Core::Form::Input ;
require Core::Configuration ;

@ISA = qw(Core::Form::Input Core::Configuration);

# set up logging
require "$ENV{'NPRWEB_DIR'}/cgi/Lib/Logger.pm";
my $logger = new Logger( $ENV{NPRWEB_NPR_LOGFILE}, $ENV{NPRWEB_NPR_LOGLEVEL} );

##################################################################################
#
# Function    : new
#
# Parameters  : none
#
# Description : First thoughts
#
# Returns     : First thoughts, return a hash containg each input entry field plus
#               details
# Called By   :
#
##################################################################################
sub new {
    my $proto = shift;    # get the class name
    my $class = ref($proto) || $proto;
    # if class exists, use it else use reference.
    my $this = {MW_system => {},
                @_} ;
    $this->{plotlist} = () ;
    $this->{columnlist} = () ;
    $this->{plot_table} = "" ;
    $this->{cache_sep} = "" ;
    $this->{cbname} = "" ;
    $this->{cbid} = "" ;
    $this->{element_number} = 0 ;

    $this->{DB_type} = () ;
    $this->{DB_name} = () ;
    $this->{DB_displayname} = () ;
    $this->{item} = "";

    bless $this, $class;
    return $this ;

}

##################################################################################
#
# Function    : panel()
#
# Parameters  : $tabNumber - tab number,
#               $tabInfo - tab information
#
# Description : generates html tagged panel of elements for the gui
#
# Returns     : html string
#
# Called By   : displayCB()
#
##################################################################################
sub panel {
    my ($this, $tabNumber, $tabInfo) = @_ ;
    my $pane = "" ;

	$pane .= qq{
	<div id="panel_$tabNumber" class="panel" selected="$$tabInfo{selected}">
	    <table width="495">
        <tr><td colspan='3'></td></tr>
    } ;

    if ( $tabNumber == 0 ) {
        $this->main() ;
        # handle hidden data items
        $pane .= $this->elementsForm($tabNumber, $tabInfo) ;
    } elsif ( $tabNumber == 1 ) {
        # handle database items
        $pane .= $this->datesForm($tabNumber, $tabInfo) ;
    } elsif ( $tabNumber == 2 ) {
        # handle data items
        $pane .= $this->plotsForm($tabNumber, $tabInfo) ;
    }

	$pane .= qq{
	    </table>
	</div>
	} ;

	return $pane ;
}

##################################################################################
#
# Function    : getCachePlotList
#
# Parameters  : none
#
# Description : First thoughts
#
# Returns     : First thoughts, return a hash containg each input entry field plus
#               details
# Called By   : main()
#
##################################################################################
sub getCachePlotList {

    my($this) = @_ ;

    # Get data from cache file
    #
    my ($file_cbid, $file_table, $file_plotname, $file_colname, $file_exp, $file_colname);
    open(CBCONFIGFILE, "${ENV{NPR_WWW_CACHE_DIR}}/CBID-TABNAME-COUNTERNAME-COLNAME-EXPRESSION-C_CLIST.dat") or
        $logger->log("cbparam.htm: Cannot open ${ENV{NPR_WWW_CACHE_DIR}}\/CBID-TABNAME-COUNTERNAME-COLNAME-EXPRESSION-C_CLIST.dat cache file",2) and
        die "1000; cache file ${ENV{NPR_WWW_CACHE_DIR}}\/CBID-TABNAME-COUNTERNAME-COLNAME-EXPRESSION-C_CLIST.dat";

    foreach(<CBCONFIGFILE>) {
        chomp;
        ($file_cbid, $file_table, $file_plotname, $file_colname, $file_exp) = split /$this->{cache_sep}/, $_, 5;
        if($file_cbid eq $this->{cbid}) {

            # Get the first table name (for plot expressions)
            if ($this->{plot_table} == ''){$this->{plot_table}=$file_table;}

	    if ($this->{MW_system}{CBTYPE} eq 'S') {
		$this->{plot_table} .= '_DY';
	    }

            # The line above somehow always fails, that is plot_table is always assigned a new
            # value so the code below populates an array with the table names associated with 
            # the columns

            # If a column name exists it must be a plot.
            if($file_colname ne "") {
		$file_colname = $this->{plot_table}.":".$file_colname;
                $this->{plotlist}{$file_plotname} = $file_colname;
		$this->{columnlist}{$file_colname} = $file_colname;
            }

            # If an expression exists it's an expression.
            elsif(defined $file_exp) {
                $_ = $file_exp;
                $this->{plotlist}{"$file_plotname"} = $_;
            }
        }
    }
    close(CBCONFIGFILE);

}

##################################################################################
#
# Function    : getDBPlotList
#
# Parameters  : none
#
# Description : First thoughts
#
# Returns     : First thoughts, return a hash containg each input entry field plus
#               details
# Called By   : main()
#
##################################################################################
sub getDBPlotList {

    my ($this) = @_ ;
    my $id = $$;
    my $tslscriptfile = "$this->{MW_system}{MW_NPRWEB_TMPDIR}/tslscript.$id";
    my $cbplotfile = "$this->{MW_system}{MW_NPRWEB_TMPDIR}/cbplotout.$id";
    my $xferfile = "$this->{MW_system}{MW_NPRWEB_TMPDIR}/cbplotxfer.$id";
    my $errfile = "$this->{MW_system}{MW_NPRWEB_TMPDIR}/errfile.$id";
    my @err_data;

    # Get data from database.
    if( !open(TSLSCRIPT, ">$tslscriptfile") ) {
         $logger->log("cbparam.htm: cannot create $tslscriptfile",2);
         die "1002; cbparam.htm: tsl script file $tslscriptfile";
    }

    print TSLSCRIPT "query SELECT tabname, countername, colname, expression from c_clist where cbid=\"$this->{cbid}\";\n";

    if($this->{MW_system}{CBTYPE} eq 'S') {
        print TSLSCRIPT "query UPDATE tabname+\"_DY\" as tabname from RSLT;\n";
    }

    print TSLSCRIPT qq[
        printer on
	margin 1
	transfer property set media=1 format=1 delimiter=":" terminator=0
	transfer unload RSLT cat >> $xferfile
        printer off
        query DROP RSLT;
	];
    close (TSLSCRIPT);

    # run webrun and test the exit status
    #
    $command="webrun $id $tslscriptfile $cbplotfile $errfile CBInp";
    my $exit_status = &main::time_out_and_clean_up( $command, $timeout, $errfile, $errfile );

    if ( $exit_status != 0 ) {
        # Check for Error file
        if( open(ERRORFILE, "<$errfile")){
            foreach(<ERRORFILE>) {
                chomp;
                push @err_data, $_;
            }
            unlink($errfile);
        }
        $logger->log("cbparam.htm(1): webrun has failed with exitstatus $exit_status\n @err_data",2);
        die "$exit_status; cbparam.htm(1): Request to Database has failed <br> @err_data <br>";
    }

    unlink($tslscriptfile, $cbplotfile, $errfile);

    # Store the data into list of hash
    my ($table, $the_plot_name, $column, $expression, $the_col_name);

    if ( !open(PLOTFILE, "<$xferfile") ) {
        $logger->log("cbparam.htm: cannot open $xferfile",2);
        die "1000; cbparam.htm: cb_plot file $xferfile";
    }

    foreach (<PLOTFILE>) {
            chomp;
            ($table, $the_plot_name, $column, $expression) = split /:/, $_;

	    # Storing the into 2 separate lists i.e. 
	    # Plot creation list (plotlist) and Expression creation list (columnlist)
            if($column ne "") {
		$the_col_name = $table.":".$column;
                $this->{plotlist}{$the_plot_name} = $column;
		$this->{columnlist}{$the_col_name} = $column;

            } elsif(defined $expression) {
		# If an expression exists, it's an expression (not a simple plot).
                $_ = $expression;
                $this->{plotlist}{"$the_plot_name"} = $_;
            }
    }
    close(PLOTFILE);
    unlink($xferfile);

}

##################################################################################
#
# Function    : getCacheEelementTypes
#
# Parameters  : none
#
# Description : First thoughts
#
# Returns     : First thoughts, return a hash containg each input entry field plus
#               details
# Called By   : main()
#
##################################################################################
sub getCacheEelementTypes {

    my ($this) = @_ ;
    my @elementTypes = ();

    # Get data from cache.
    my ($p_tablename, $key_columnname);

    # Now, consult the primary key file to work out the element type.
    if ( !open(PRIMARYFILE, "<${ENV{NPR_WWW_CACHE_DIR}}/PRIMARY.dat") ) {
        $logger->log("cbparam.htm: Cannot open ${ENV{NPR_WWW_CACHE_DIR}}/PRIMARY.dat",2 );
        die "1000; cbparam.htm: cache file PRIMARY.dat";
    }
    while(<PRIMARYFILE>) {
        chomp;
        ($p_tablename, $key_columnname) = split /$this->{cache_sep}/, $_, 2;
        if($p_tablename eq $this->{plot_table}) {
            push @elementTypes, $key_columnname;
        }
    }
    close(PRIMARYFILE);
    return \@elementTypes ;
}

##################################################################################
#
# Function    : getDBEelementTypes
#
# Parameters  : none
#
# Description : First thoughts
#
# Returns     : First thoughts, return a hash containg each input entry field plus
#               details
# Called By   : main()
#
##################################################################################
sub getDBEelementTypes {

    my ($this) = @_ ;
    my @elementTypes = ();

    # Get data from NPR database.
    my $id = $$;
    my $tslscriptfile = "$this->{MW_system}{MW_NPRWEB_TMPDIR}/tslscript$id.tsl";
    my $cboutfile = "$this->{MW_system}{MW_NPRWEB_TMPDIR}/cb$id.out";
    my $errfile = "$this->{MW_system}{MW_NPRWEB_TMPDIR}/errfile$id.err";
    my @err_data;

    if ( !open (TSLSCRIPT, ">$tslscriptfile") ) {
        $logger->log("cbparam.htm: Cannot create $tslscriptfile",2);
        die "1002; cbparam.htm: tsl script file $tsl script file";
    }
    print TSLSCRIPT "query SET %UNIQUE TRUE;\n";
    print TSLSCRIPT "query SELECT TABNAME FROM C_CLIST WHERE CBID=\"$this->{cbid}\";\n";
    print TSLSCRIPT "query SET %UNIQUE FALSE;\n";

    if($this->{MW_system}{CBTYPE} eq 'S') {
        print TSLSCRIPT "query UPDATE TABNAME+\"_DY\" AS TABNAME FROM RSLT;\n";
    }
    print TSLSCRIPT "query SELECT %INAME, TABNAME FROM %COLS, RSLT JOIN %RNAME=TABNAME WHERE %KEY=true;
	query DISPLAY %INAME, TABNAME FROM RSLT, %ITEMS JOIN %INAME=%INAME WHERE %ITYPE<>4;
	pagestyle startline=1 lmargin=1 rmargin=80 length=99999
        report on
        printer on
        if %rows <> 0
	    repeat
		'[%INAME]
		next
	    forall
        endif
        printer off
        query DROP RSLT;\n";
    close (TSLSCRIPT);

    # run webrun and test the exit status then remove duplicated lines from the
    # output file
    #
    $command="webrun $id $tslscriptfile $cboutfile.tmp $errfile CBInp";
    $exit_status = &main::time_out_and_clean_up( $command, $main::timeout, $errfile, $errfile );

    if ( $exit_status != 0 ) {
        # Check for Error file
        if( open(ERRORFILE, "<$errfile")){
            foreach(<ERRORFILE>) {
                chomp;
                push @err_data, $_;
            }
            unlink($errfile);
        }
        $logger->log("cbparam.htm(3): webrun has failed with exitstatus $exit_status\n @err_data",2);
        die "$exit_status; cbparam.htm(3): Request to Database has failed <br> @err_data <br>";
    }
    unlink($tslscriptfile, $errfile);
    system("uniq $cboutfile.tmp > $cboutfile;rm $cboutfile.tmp");

    # Load the query results into an array.

    if ( !open(TABLEFILE, "<$cboutfile") ) {
        $logger->log("cbparam.htm: cannot open $cboutfile",2);
        die "1000; cbparam.htm: cb_out file $cboutfile";
    }
    foreach(<TABLEFILE>) {
        chomp;
        push @elementTypes, $_;
    }
    close(TABLEFILE);
    unlink($cboutfile);

    return \@elementTypes ;
}

##################################################################################
#
# Function    : elementsForm
#
# Parameters  : $tabNumber - tab number,
#               $tabInfo - tab information
#
# Description : First thoughts
#
# Returns     : First thoughts, return a hash containg each input entry field plus
#               details
# Called By   : main()
#
##################################################################################
sub elementsForm {

    my ($this,$tabNumber,$tabInfo) = @_ ;
    my $dialog = "" ;

    ##NAS# network elements

    my $DisplayType;
    my ($DBName, $DisplayName, $Width, $DBtab, @SelectBy);
    my $Value;
    my ($VarList, $DBTypeName, $TypeName, $TableName);

    $dialog .= qq[<table cellspacing=9 cellpadding=0 border=0 bordercolor="#000000" bordercolorlight="#888888">\n];

    # Additional code for Bug 22054 and 20011
    # Create a list of counter browser elements.
    my @CBElist;
    foreach (sort keys %{$this->{MW_system}}) {
            if(/^CBE/) {
                    last if($this->{MW_system}{$_} eq '');
                    push @CBElist, $_;
            }
    }

    # If there's only one element type then this is an ordinary counter
    # browser, so display only one select by list and three element
    # selection text fields.

    my ($DB_type, $DB_dbname, $DB_displayname, $DB_table, @DB_selectby);
    my ($OtherTableName, $byitem, $OtherTypeName, $OtherRest, $OtherDBTypeName);

    if($this->{element_number} == 1) {

            # NL 26/09/01 - New select by mechanism added to CB's
            #
            my @menu = ();
            my %menuVal = ();

        $DB_type = shift @{$this->{DB_type}};
            $DB_dbname = shift @{$this->{DB_name}};
            $DB_displayname = shift @{$this->{DB_displayname}};
            $DB_table = shift @DB_table;
            $DB_selectby = shift @DB_selectby;

            # Set up 'Select by:'.

        $DisplayType = $DB_type;
        $DisplayType =~ s/\s//g;
        $DisplayType = lc $DisplayType;
        $DBName = ${$this->{dataBaseItems}}{$DisplayType}{DBName};
        $DisplayName = ${$this->{dataBaseItems}}{$DisplayType}{DisplayName} ;
        $Width = ${$this->{dataBaseItems}}{$DisplayType}{Width} ;
        $DBtab = ${$this->{dataBaseItems}}{$DisplayType}{TableName} ;
        @SelectBy = @{${$this->{dataBaseItems}}{$DisplayType}{SelectBy}};
        $DBName = uc($DBName);
        $Value = $DBName;
        $Value =~ /CELLID/ and $Value = 'CELLNAME';
        @SelectBy = map {lc $_} @SelectBy;

            push @menu, "Select $DisplayName by";

        foreach $byitem (@SelectBy) {

            # Search through the Types hash (containing all the info
            # from DBInfo) and obtain the correct table name from which
            # to extract a list of elements.

            # First, get what we hope is the correct data.

            $DBTypeName = ${$this->{dataBaseItems}}{$byitem}{DBName};
            $TypeName = ${$this->{dataBaseItems}}{$byitem}{DisplayName} ;
            $TableName = ${$this->{dataBaseItems}}{$byitem}{TableName} ;
            $TableName = uc($TableName);
            $DBTypeName = uc($DBTypeName);

            # Now, go through the Types hash and see if there are any more lines
            # that refer to the same columnname.

            foreach(keys %{$this->{dataBaseItems}}) {
                if($_ ne $byitem) {
                    $OtherDBTypeName = ${$this->{dataBaseItems}}{$_}{DBName};
                    $OtherTypeName = ${$this->{dataBaseItems}}{$_}{DisplayName} ;
                    $OtherTableName = ${$this->{dataBaseItems}}{$_}{TableName} ;
                    $OtherDBTypeName = uc($OtherDBTypeName);
                    if($OtherDBTypeName eq $DBTypeName) {
                        $OtherTableName = uc($OtherTableName);
                        if($OtherTableName eq $this->{MW_system}{TBLNME}) {
                            $TableName = $OtherTableName;
                            $DBTypeName = $OtherDBTypeName;
                            $TypeName = $OtherTypeName;
                            last;
                        }
                    }
                }
            }

            $VarList = $byitem =~ /network/ ? "$DisplayName:$DisplayType:$DBName:$this->{MW_system}{TBLNME}" : "$TypeName:$_:$DBTypeName:$TableName:$DisplayName:$DisplayType:$DBName:$this->{MW_system}{TBLNME}";
            $VarList =~ s/:/%3A/g;
            $VarList =~ s/\s/+/g;

            # Create the 'select by' link.  An extra value, EIU (element in use) is passed
            # which allows the hierarchy list to place the selected element in the correct
            # text field.

            $this->{MW_system}{CBE} = $DB_dbname = uc($DB_dbname);
            $this->{MW_system}{CBE2} = '';

            $menuVal{$TypeName}  = "$this->{MW_system}{CGIPROG}?NPRSYS=$this->{MW_system}{NPRSYS}&EIU=";
            $menuVal{$TypeName} .= $this->{MW_system}{CBE};
            $menuVal{$TypeName} .= "&NPRTARGET=frm_cbSelect.htm&SELECTLIST=$VarList";

                    push @menu, $TypeName;
        }

        $dialog .= qq[<tr style='color:white;font-weight:bold;'><td>$DisplayName</td>];

        # dont show select box for manually entered items
        $logger->log("info - menu = @menu",4) ;
        if( ! $menu[1] ) {
            #$dialog .= "<td>Select $DisplayName</td>";


        } else {
            # alternative select mechanism
        	$dialog .= qq[
        		<td align="left">
        			<input type="image" value="list" src="/images/buttons/drop_arrow.gif" title="List network elements" onclick="getSelect(this);return false;" name="list" href="$this->{MW_system}{CGIPROG}?NPRSYS=$this->{MW_system}{NPRSYS}&EIU=$this->{MW_system}{CBE}&NPRTARGET=frm_cbSelect.htm&SELECTLIST=$DisplayType&FIRSTPASS=true&SELECTTYPE=$DisplayName&amp;CURRSELECT=$DisplayType&amp;CURRSELECTBY=" />
        		</td>] ;
       }
       $dialog .= qq[</TR>\n];

        # Create network element text fields.

        foreach (1, 2, 3) {
            $dialog .= qq[<tr><td>$_:</td>\n];
            if ($ENV{ELEMENT_SUGGESTION} eq "False") {
               $dialog .= qq[<td align='left'><input id='$DB_dbname$_' type='text' techlayer="$this->{MW_system}{TECH_LAYER}" nprsys="$this->{MW_system}{NPRSYS}" size=30 dbItem='$DisplayType' name='$DB_dbname$_' value=''></td></tr>\n];
            } else {
              my $divID = $DB_dbname.$_."Div";
              $dialog .= qq[
                      <td align='left'>
                          <input id='$DB_dbname$_' type='text' techlayer="$this->{MW_system}{TECH_LAYER}" nprsys="$this->{MW_system}{NPRSYS}" size=30 onkeyup="doSuggestion(this); return false;" maxSuggest="$ENV{ELEMENT_SUGGESTION}" dbItem='$DisplayType' name='$DB_dbname$_' value=''><br><div id="$divID" visibility="hidden" position="absolute"></div>
                      </td></tr>\n];
            }
        }
    } elsif($this->{element_number} > 1) {

        # If there are two element types then six element selection
        # fields are needed.

        $dialog .= qq[<tr align='left' style='color:white;font-weight:bold;'>] ;

        # Now, set up the two select by methods.

        $dialog .= qq[<tr valign=top>\n];

        my $cbe_extension = '';
        my ($tp, $cbecounter);
        $cbecounter = 1;
        my %fldhash;
        foreach $tp (@{$this->{DB_type}}) {

            # NL 26/09/01 - New select by mechanism added to CB's
            #
            my @menu = ();
            my %menuVal = ();

            $DB_dbname = shift @{$this->{DB_name}};
            $DB_displayname = shift @{$this->{DB_displayname}};
            $DB_table = shift @DB_table;
            $DB_selectby = shift @DB_selectby;

            $DisplayType = $tp;
            $DisplayType =~ s/\s//g;
            $DisplayType = lc $DisplayType;
            $DBName = ${$this->{dataBaseItems}}{$DisplayType}{DBName};
            $DisplayName = ${$this->{dataBaseItems}}{$DisplayType}{DisplayName} ;
            $Width = ${$this->{dataBaseItems}}{$DisplayType}{Width} ;
            $DBtab = ${$this->{dataBaseItems}}{$DisplayType}{TableName} ;
            @SelectBy = @{${$this->{dataBaseItems}}{$DisplayType}{SelectBy}};
            $DBName = uc($DBName);
            $Value = $DBName;
            $Value =~ /CELLID/ and $Value = 'CELLNAME';
            @SelectBy = map {lc $_} (@SelectBy);

            push @menu, "Select $DisplayName by";

            foreach $byitem (@SelectBy) {
                $DBTypeName = ${$this->{dataBaseItems}}{$byitem}{DBName};
                $TypeName = ${$this->{dataBaseItems}}{$byitem}{DisplayName} ;
                $TableName = ${$this->{dataBaseItems}}{$byitem}{TableName} ;
                $TableName = uc($TableName);
                $DBTypeName = uc($DBTypeName);
                foreach(keys %{{$this->{dataBaseItems}}}) {
                    if($_ ne $byitem) {
                        $OtherDBTypeName = ${$this->{dataBaseItems}}{$_}{DBName};
                        $OtherTypeName = ${$this->{dataBaseItems}}{$_}{DisplayName} ;
                        $OtherTableName = ${$this->{dataBaseItems}}{$_}{TableName} ;
                        $OtherDBTypeName = uc($OtherDBTypeName);
                        if($OtherDBTypeName eq $DBTypeName) {
                            $OtherTableName = uc($OtherTableName);
                            if($OtherTableName eq $this->{MW_system}{TBLNME}) {
                                $TableName = $OtherTableName;
                                $DBTypeName = $OtherDBTypeName;
                                $TypeName = $OtherTypeName;
                                last;
                            }
                        }
                    }
                }
                if($cbecounter < 2) {
                    $VarList = $byitem =~ /network/ ? "$DisplayName:$DisplayType:$DBName:$this->{MW_system}{TBLNME}" : "$TypeName:$_:$DBTypeName:$TableName:$DisplayName:$DisplayType:$DBName:$this->{MW_system}{TBLNME}";
                }
                else {
                    $VarList = $byitem =~ /network/ ? "$DisplayName:$DisplayType:$DBName:$this->{MW_system}{'TBLNME' . $cbecounter}" : "$TypeName:$_:$DBTypeName:$TableName:$DisplayName:$DisplayType:$DBName:$this->{MW_system}{'TBLNME' . $cbecounter}";
                }
                $VarList =~ s/:/%3A/g;
                $VarList =~ s/\s/+/g;

                # Create the 'select by' link.  An extra value, EIU (element in use) is passed
                # which allows the hierarchy list to place the selected element in the correct
                # text field.

                $menuVal{$TypeName} = "$this->{MW_system}{CGIPROG}?NPRSYS=$this->{MW_system}{NPRSYS}&EIU=";
                if($cbecounter > 1) {
                    $menuVal{$TypeName} .= $this->{MW_system}{"CBE" . $cbecounter};
                }
                else {
                    $menuVal{$TypeName} .= $this->{MW_system}{"CBE"};
                }
                $menuVal{$TypeName} .= "&NPRTARGET=frm_cbSelect.htm&SELECTLIST=$DisplayType&FIRSTPASS=true&SELECTTYPE=$DisplayName";

                push @menu, $TypeName;

            }

            $logger->log("info - \$DisplayName = $DisplayName",4) ;

            $dialog .= qq[<td><b>$DisplayName</b></td>\n];

            # dont show select box for manually entered items
            if( ! $menu[1] ) {
                        #$dialog .= "<td>Select $DisplayName</td>";
                        $dialog .= "<td><font size=1>*manually entered items</font></td>";
            } else {
	            $fldhash{$DisplayType} = 1;
    			$dialog .= qq[<td align="left"><input type="image" src="/images/buttons/drop_arrow.gif" title="List network elements" value="list" onclick="getSelect(this);return false;" name="list" href="$menuVal{$TypeName}&amp;CURRSELECT=$DisplayType&amp;CURRSELECTBY=" /></td>] ;

            }

            #$logger->log("info - \$cbecounter = $cbecounter",4) ;

            $cbecounter++;
            $cbe_extension = '2';
        }
        $dialog .= qq[</tr>\n];

        $dialog .= qq[<script language="JavaScript">\n];
        $dialog .= qq[function BadCheckWithSecondSet() {\n];
        if($this->{MW_system}{CBE2} ne '') {
            $dialog .= qq[with(document.nprform1) {\n];
            $dialog .= qq[if(($this->{MW_system}{CBE}1.value != '' && $this->{MW_system}{CBE2}1.value == '') ||\n];
            $dialog .= qq[($this->{MW_system}{CBE}2.value != '' && $this->{MW_system}{CBE2}2.value == '') ||\n];
            $dialog .= qq[($this->{MW_system}{CBE}3.value != '' && $this->{MW_system}{CBE2}3.value == '')) {\n];
            $dialog .= qq[return 1;\n];
            $dialog .= qq[}\n];
            $dialog .= qq[if(($this->{MW_system}{CBE}1.value == '' && $this->{MW_system}{CBE2}1.value != '') ||\n];
            $dialog .= qq[($this->{MW_system}{CBE}2.value == '' && $this->{MW_system}{CBE2}2.value != '') ||\n];
            $dialog .= qq[($this->{MW_system}{CBE}3.value == '' && $this->{MW_system}{CBE2}3.value != '')) {\n];
            $dialog .= qq[return 2;\n];
            $dialog .= qq[}\n];
            $dialog .= qq[}\n];
        }
        $dialog .= qq[return 0;\n];
        $dialog .= qq[}\n];
        $dialog .= qq[</script>\n];

        # Create network element text fields for all element types

        my ($enumber, $textfieldwidth);
        $textfieldwidth = ($this->{element_number} < 3) ? 23 : 15;
        foreach $enumber (1, 2, 3) {
            $dialog .= qq[<tr>\n];
            my $ind = 0;
            foreach (@CBElist) {
                $dialog .= qq[<td align='right'>$enumber:</td>\n];
                if ($fldhash{$this->{DB_type}[$ind]}) {
                   if ($ENV{ELEMENT_SUGGESTION} eq "False") {
                      $dialog .= qq[<td align='left'><input type='text' size=$textfieldwidth techlayer="$this->{MW_system}{TECH_LAYER}" nprsys="$this->{MW_system}{NPRSYS}" dbItem='$this->{DB_type}[$ind]' name='$this->{MW_system}{$_}$enumber' id='$this->{MW_system}{$_}$enumber' value=''></td>\n];
                   }else {
                         my $divID = $this->{MW_system}{$_}.$enumber."Div";
             	         $dialog .= qq[
                                 <td align='left'>
                                 <input type='text' size=$textfieldwidth techlayer="$this->{MW_system}{TECH_LAYER}" nprsys="$this->{MW_system}{NPRSYS}" maxSuggest="$ENV{ELEMENT_SUGGESTION}" onkeyup="doSuggestion(this); return false;" dbItem='$this->{DB_type}[$ind]' name='$this->{MW_system}{$_}$enumber' id='$this->{MW_system}{$_}$enumber' value=''><br><div id="$divID" visibility="hidden" position="relative"></div>
                                 </td>\n
                                 ];
               	   }
              	}else{
                	$dialog .= qq[<td align='left'><input type='text' size=$textfieldwidth name='$this->{MW_system}{$_}$enumber' id='$this->{MW_system}{$_}$enumber' value=''></td>\n];
              	}
                $ind++;
            }
            $dialog .= qq[</tr>\n];
        }
    }

    $dialog .= qq[</table>\n];

    return $dialog ;

}

##################################################################################
#
# Function    : datesForm
#
# Parameters  : $tabNumber - tab number,
#               $tabInfo - tab information
#
# Description : First thoughts
#
# Returns     : First thoughts, return a hash containg each input entry field plus
#               details
# Called By   : main()
#
##################################################################################
sub datesForm {
    my ($this,$tabNumber,$tabInfo) = @_ ;
    my $dialog = "" ;

    $dialog .= qq[<table cols='3' width='300' align='left'>] ;

    # If CB type is historical, display the summary type selection
    # popup and the trend start and trend end date fields.  Otherwise
    # display the target date field only.

    if($this->{MW_system}{CBTYPE} eq 'S') {
        $dialog .= qq[<input type=hidden name=WKEX value='$this->{MW_system}{WKEX}'>\n];
        $dialog .= qq[<input type=hidden name=DYEX value='$this->{MW_system}{DYEX}'>\n];
        $dialog .= qq[<input type=hidden name=APPLYWKEXCL value='$this->{MW_system}{APPLYWKEXCL}'>\n];
        $dialog .= qq[<input type=hidden name=APPLYDYEXCL value='$this->{MW_system}{APPLYDYEXCL}'><br>\n];
        my @fieldsArray = ('sort_day_week_month','startd','endd') ;
        $dialog .= $this->_NPRVars($tabNumber,\@fieldsArray) ;
    }
    else {
        my @fieldsArray = ('targetd','dbefore','dafter') ;
        $dialog .= $this->_NPRVars($tabNumber,\@fieldsArray) ;
    }

        $dialog .= qq[</table>\n];

    return $dialog
}

##################################################################################
#
# Function    : plotsForm
#
# Parameters  : none
#
# Description : First thoughts
#
# Returns     : First thoughts, return a hash containg each input entry field plus
#               details
# Called By   : main()
#
##################################################################################
sub plotsForm {

    my ($this) = @_ ;

    my $dialog = "" ;
    $dialog .= qq[<table cellspacing=9 cellpadding=0 border=0>\n];
    $dialog .= qq[<tr><td style='color:white;font-weight:bold;'><b>Plots</b></td></tr>];

    # Bug 14244, set defaults for the initial pop up list.
    # Read in the cb config (cb_conf.cfg) file which specifies the first plot to go in the list
    my ($cb_confid, $cb_firstPlot, $plot_no);
    my %cb_initHash;
    my $cbconf = $this->readcbConfig("$this->{MW_system}{MW_NPRWEB_TECH}/cb_conf.cfg");

    foreach ( keys %{$cbconf} ) {
        $cb_confid = $$cbconf{$_}{Name};
        $cb_firstPlot = $$cbconf{$_}{counterName};
        $cb_initHash{$cb_confid} = $cb_firstPlot;
    }

    foreach (1, 2, 3) {
        $plot_no = $_;
        $dialog .= qq[<tr><td align='right' style='color:white;'>Plot $_:</td>\n];
        $dialog .= qq[<td align='left'><select id='PLOT$_' name='PLOT$_'>\n];
        if( $_ == 1 && $cb_initHash{$this->{cbid}}) {
            $dialog .= qq[<option value='$cb_initHash{$this->{cbid}}'>$cb_initHash{$this->{cbid}}\n];
            }
        $dialog .= qq[<option selected value='None'>None\n] if($_ > 1);
        foreach (sort keys %{$this->{plotlist}}) {
            if ( $_ eq $cb_initHash{$this->{cbid}} and $plot_no == 1 ) { next;}
            $dialog .= qq[<option value='$_'>$_\n];
        }
        $dialog .= qq[</select></td></tr>\n];
    }
    $dialog .= qq[</table>\n];

foreach $DB_dbname ( @{$this->{TMP_DB_name}} ) {

    # Bug 24325 Identify Database elements ending in CELLID ready for conversion from
    # cellname to cellid SKT 15/05/01
    $dialog .= qq[<input type="hidden" name="NPRSYS" value=$this->{MW_system}{NPRSYS}>\n];
    if($DB_dbname =~ /CELLID/ || $DB_dbname eq 'SSID' || $DB_dbname eq 'TRAFFTYPE' || $DB_dbname_two =~ /CELLID/ || $DB_dbname_two eq 'SSID' || $DB_dbname_two eq 'TRAFFTYPE') {
        $dialog .= qq[<input type="hidden" name="NEXTTARGET" value="cbgraph.htm">\n];
        $dialog .= qq[<input type="hidden" name="NPRTARGET" value="frm_cbConvCellname.htm">\n];
    }
    else {
        $dialog .= qq[<input type="hidden" name="NPRTARGET" value="cbgraph.htm">\n];
    }
}

    # Plot expressions
    $dialog .= qq[<input type="hidden" name="h_plot1" value="empty">\n];
    $dialog .= qq[<input type="hidden" name="h_plot2" value="empty">\n];
    $dialog .= qq[<input type="hidden" name="h_plot3" value="empty">\n];
    $dialog .= qq[<input type="hidden" name="tab_name1" value="empty">\n];

    # Plot expression dialog box
    $dialog .= qq[<hr /><table><tr><td style='color:white;font-weight:bold;'>Expressions</td></tr>\n];
    $dialog .= qq[<tr><td class='panelText'>Expression 1</td><td><input id='P1' type='text' name='P1' width='20' value='' /></td><td><input type='image' id='Plot1' src='/images/buttons/addToPlot1.gif' name='atp1' value='Add to Plot 1' onclick='addExpression(1); return false;' onmouseover=\"MM_swapImage('Plot1','','/images/buttons/addToPlot1_over.gif',1)\" onmouseout=\"MM_swapImgRestore()\"/></td></tr>\n];
    $dialog .= qq[<tr><td class='panelText'>Expression 2</td><td><input id='P2' type='text' name='P2' width='20' value='' /></td><td><input type='image' id='Plot2' src='/images/buttons/addToPlot2.gif' name='atp2' value='Add to Plot 2' onclick='addExpression(2); return false;' onmouseover=\"MM_swapImage('Plot2','','/images/buttons/addToPlot2_over.gif',1)\" onmouseout=\"MM_swapImgRestore()\"/></td></tr>\n];
    $dialog .= qq[<tr><td class='panelText'>Expression 3</td><td><input id='P3' type='text' name='P3' width='20' value='' /></td><td><input type='image' id='Plot3' src='/images/buttons/addToPlot3.gif' name='atp3' value='Add to Plot 3' onclick='addExpression(3); return false;' onmouseover=\"MM_swapImage('Plot3','','/images/buttons/addToPlot3_over.gif',1)\" onmouseout=\"MM_swapImgRestore()\"/></td></tr></table>\n];
    $dialog .= qq[<hr /><table><tr><td colspan='2' style='color:white;font-weight:bold;'>Columns];
    $dialog .= qq[</td></tr>\n];


    # Build columns for tables in the Expression creation list
    my %table_test;
    $dialog .= qq[<tr><td valign='top' rowspan='3' class='panelText'>Column Names</td><td><select id='columnName' name=columnName size='3'>] ;

    foreach (sort keys %{$this->{columnlist}}) {
	($table,$column) = split /:/, $_;
	if ( !$table_test{$table} ) {
	    $table_test{$table} = 1;
	    $dialog .= qq[<optgroup label='$table columns'>];
	}
	$dialog .= qq[<option value='$column:$table' >$table - $column</option>\n];
    }
    $dialog .= qq[</optgroup>];

    $dialog .= qq[</select></td>];

    $dialog .= qq[<td><table><tr><td><input type='image' id='Expr1' src='/images/buttons/addToExpression1.gif' name='ate1' value='Add to Expression 1' onclick='addColumn(1); return false;' onmouseover=\"MM_swapImage('Expr1','','/images/buttons/addToExpression1_over.gif',1)\" onmouseout=\"MM_swapImgRestore()\" /></td></tr>\n];
    $dialog .= qq[<tr><td><input type='image' id='Expr2' src='/images/buttons/addToExpression2.gif' name='ate2' value='Add to Expression 2' onclick='addColumn(2); return false;' onmouseover=\"MM_swapImage('Expr2','','/images/buttons/addToExpression2_over.gif',1)\" onmouseout=\"MM_swapImgRestore()\"'/></td></td></tr>\n];
    $dialog .= qq[<tr><td><input type='image' id='Expr3' src='/images/buttons/addToExpression3.gif' name='ate3' value='Add to Expression 3' onclick='addColumn(3); return false;' onmouseover=\"MM_swapImage('Expr3','','/images/buttons/addToExpression3_over.gif',1)\" onmouseout=\"MM_swapImgRestore()\"'/></td></td></tr></table></td></tr>\n];

    $dialog .= qq[</table>];
    $dialog .= qq[<input type='hidden' value='empty' name='tab_name' id='tab_name'/>\n];


    ####

    if( !($dialog =~ /function\s+onLoadScript\(/ )) {
            $dialog .= qq[<SCRIPT language=JavaScript>\n];
            $dialog .= qq[function onLoadScript() {\n];
        if($this->{MW_system}{CBTYPE} eq 'R') {
                $dialog .= qq[  setSelectByValue(document.nprform1.DBEFORE, '\$\$DBEFORE\$\$');\n];
            $dialog .= qq[  setSelectByValue(document.nprform1.DAFTER, '\$\$DAFTER\$\$');\n];
            } else {
            $dialog .= qq[  setSelectByValue(document.nprform1.SUMMARY, '\$\$SUMMARY\$\$');\n];
        }
        $dialog .= qq[}\n</SCRIPT>\n];
     }
    return $dialog
}

##################################################################################
#
# Function    : main
#
# Parameters  : none
#
# Description : the main CB dialog function
#
# Returns     : nothing
#
# Called By   : panel()
#
##################################################################################
sub main {

    my ($this) = @_ ;
    # Generate a form requesting network element and plot selections
    # for the chosen counter browser.
    my $rmethod ;
    my $elementTypes = () ;

    if ( $this->{MW_system}{RM} eq "" ) {
       $rmethod = "DATABASE" ;
    } else {
       $rmethod = $this->{MW_system}{RM} ;
    }

    $logger->log("info - \$this->{MW_system}{RM} = $this->{MW_system}{RM}",4) ;
    $this->{cache_sep} = exists $ENV{NPR_WWW_CACHE_SEPARATOR} ? $ENV{NPR_WWW_CACHE_SEPARATOR} : ':';
    if(!exists $ENV{NPR_WWW_CACHE_DIR}) {
        die "1003; cbparam.htm: NPR_WWW_CACHE_DIR not set";
    }

    my $command;

    # Extract the counter browser ID and CB long name.
    my $temp = $this->{MW_system}{CBNAME};
    if ($temp ne "" ) {
        substr($temp, (index($temp, ' ')), 1) = ':';
        ($this->{cbid}, $this->{cbname}) = split /:/, $temp;
    }

    #Bug 23780 Escape Metacharacter '|' for use in split function
    if ($this->{cache_sep} =~ /\|/ ) {
        $this->{cache_sep} = "\\".$this->{cache_sep};
    }

    # Get a list of available plots (columns/counters) for the
    # selected counter browser.

    #NAS# get plot list and table names
    if($rmethod eq 'CACHE') {

        $this->getCachePlotList() ;
        $elementTypes = $this->getCacheEelementTypes() ;

    } elsif($rmethod eq 'DATABASE') {

        $this->getDBPlotList() ;
        $elementTypes = $this->getDBEelementTypes() ;

    } #NAS# end get plot list and table names

    # Work out what element type is needed.
    # Bug 22027.  Although several table names are used now it
    # seems that the tables associated with each CBID have the
    # same element type.  Hence there is no need to find the
    # element type for each table

    my $element_type = '';
    my $element_type_two = '';

    # Find out if there's more than one element type.  If there is then
    # we need another three entry fields.

    $logger->log("info - \@{\$elementTypes} = @{$elementTypes}",4) ;

    $this->{element_number} = scalar @{$elementTypes};

    if(!$this->{element_number}) {
        die "1010; Core::CounterBrowsers::Input.pm: Cannot determine element types for counter browser '$this->{cbname}'.\n";
    }

    # 05/04/01 Added in order to enable more than 2 primary network elements as input

    # Declare the arrays to hold the DBINFO data for all the element types.
    my (@dbinfo_line, @DB_table, @DB_selectby);
    my ($dbinfo_tmp);
    ELEMENT: foreach $element_type (@{$elementTypes}) {
            push @{$this->{DB_name}}, $element_type;

            # Get info from DBINFO into arrays.
            DBINFO: foreach(keys %{$this->{dataBaseItems}}) {
                    $element_type = lc($element_type);
                    if( ${$this->{dataBaseItems}}{$_}{DBName} eq ${element_type}) {
                        if( ${$this->{dataBaseItems}}{$_}{cbGEN} eq $this->{cbid}){
                                # A matching element has been found, so add the DBINFO line to the array.
                                push @dbinfo_line, $_;
                                # No need to check for this element anymore, so on to the next one.
                                close(DBINFO);
                                next ELEMENT;
                        }elsif( ${$this->{dataBaseItems}}{$_}{cbGEN} eq "GEN"){
                                # This may be the one, but we'll keep checking for more
                                # store the line in a temporary array
                                $dbinfo_tmp = $_;
                                # run through the rest of DBInfo looking for another potential match
                                next DBINFO;
                        }else{
                                #there is a match on element type but not cbid or "GEN" so ignore
                                next DBINFO;
                        }
                    }
                    #if we have got this far there is no match on cbid and so dbinfo_tmp is the correct line
            }
        if ($dbinfo_tmp){
            #an unspecific line has been found matching element_type, so push into @dbinfo_line
            push @dbinfo_line, $dbinfo_tmp;
            $dbinfo_tmp = ();
            next ELEMENT;
        }

        # If this point is reached then no info for an element was found.
        die "1010; Cannot find element type $element_type in ${MW_NPRWEB_TECH}/database.cfg.\n";
    }

    # take a copy of the DB_name array for use later (when deciding the NPRTARGET);
    foreach  ( @{$this->{DB_name}} ) {
	push @{$this->{TMP_DB_name}}, $_ ;
    }

    my ($dbtype, $dbnname, $dbdisplayname,  $dbtable, $dbselectby, $trash, $rubbish);
    # Load up all the arrays with the DBINFO information.

    foreach (@dbinfo_line) {
            ($dbtype, $dbname, $rubbish, $dbdisplayname, $trash,  $dbtable, $dbselectby) = split /:/, $_, 7;
            push @{$this->{DB_type}}, $dbtype;
            push @{$this->{DB_displayname}}, $dbdisplayname;
            push @DB_table, $dbtable;
            push @DB_selectby, $dbselectby;
    }

    # Load the table names for each element into the MW system hash.
    # e.g. TBLNME1, TBLNME2 etc.
    my $tabindex;
    $tabindex = 1;

    foreach (@DB_table) {
            if($tabindex == 1) {
                    $this->{MW_system}{"TBLNME"} = uc($_);
            }
            else {
                    $this->{MW_system}{"TBLNME" . $tabindex} = uc($_);
            }
            $tabindex++;
    }

    $tabindex = 1;
    foreach (@{$this->{DB_name}}) {
            if($tabindex == 1) {
                    $this->{MW_system}{"CBE"} = uc($_);
            }
            else {
                    $this->{MW_system}{"CBE" . $tabindex} = uc($_);
            }
            $tabindex++;
    }

    # Create a blank entry to indicate the end of the element list.
    $this->{MW_system}{"TBLNME" . $tabindex} = '';
    $this->{MW_system}{"CBE" . $tabindex} = '';

}

1 ;
