#!/usr/bin/perl
# *************************************************************
# @(#) web/webserver/cgi/ElementSuggestion.pl web_r3.6.2.3.1:cset.001111:22:33@(#)
#
#   Filename    : web/webserver/cgi/ElementSuggestion.pl
#
# *************************************************************
#
#                   COPYRIGHT NOTICE
#
# This file remains the intellectual property of:
#
#                       Vallent
#                    Spencer House
#                    23 Sheen Road
#                 Richmond, Surrey, UK
#
# Copyright (c) 2005 Vallent Software Systems UK. All rights reserved.
#
# **************************************************************
#
#   Description :
#
# ************************************************************
#

print "Content-type: text/html\n\n";
    
use CGI;
use Data::Dumper;

$query = new CGI;
require "Lib/dotsh.pl";

$queryString = $query->query_string() ;

$fldValue = uc($query->param('FIELDVALUE')) ;		# currently entered value in the field
$fldID = lc($query->param('IDCALL')) ;					# field that call for suggestion
$techlayer = uc($query->param('TECHLAYER')) ;					# field that call for suggestion
$nprsys = uc($query->param('NPRSYS')) ;					# field that call for suggestion

# Get which *.dat file we should refer to
my $top=$0;
$top =~ s%/[^/]+$%%;  # should give the path of the CGI directory
$top =~ s%/[^/]+$%%;  # should give the path of the Webserver directory
dotsh("$top/$nprsys/webconfig.sh");

#my $techlayer = $ENV{'WEB_TECH_TYPE'};	# Get the Tech Layer
my $techlayer = $techlayer;	# Get the Tech Layer
#$techlayer =~ s/^T//;

my $dbcfg = "$ENV{'NPRWEB_NPR_DIR'}/$techlayer/admin/database.cfg";
my $dbhash = do "$ENV{'NPRWEB_NPR_DIR'}/$techlayer/admin/database.cfg";
my $cache_dir = "$ENV{'NPRWEB_NPR_DIR'}/$techlayer/cache";
my $tablename = uc(${$dbhash}{$fldID}{TableName});
my $dbname = uc(${$dbhash}{$fldID}{DBName});
($dbname,$tablename) = _convertNames($dbname,$tablename);
$dbname =~ s/CELLID/CELLNAME/g;

my $filename = "$dbname-$tablename.dat";
my $cachefile = "$cache_dir/$filename";
_writeLog("ElementSuggestion : working for $fldID with $fldValue from $filename");

if ( ! -e $cachefile )
{
	_writeLog("ElementSuggestion : Could not locate $cachefile");
	return;
}

#### APAR for element suggestion
my $max_suggestions = $ENV{ELEMENT_SUGGESTION};

# convert $cachefile to hash-like file
my $tempfile = "$ENV{'NPRWEB_NPR_DIR'}/$techlayer/cache/suggestion.tmp";
my $string2;

# Check whether we have the hash, create it if we don't have	
my $shash = do $tempfile;
if (exists $$shash{$dbname}) {
	_writeLog("We have hash for $dbname");
	my $first_char = substr($fldValue,0,1);
	my @sarray = @{$$shash{$dbname}{$first_char}};
	my $index=1;
	foreach (@sarray) {
		if (uc($_) =~ /^$fldValue/) {
			if ($index==1) {
				$string2 = $_;
			}else{
				$string2 .= "::".$_;
			}
			$index++;
		}
	}
}else{
	_writeLog("We don't have hash for $dbname, need to populate it from $filename");
	
	# Read from cache file
	open (CACHEFILE, "< $cachefile");
	my %suggestion_hash;
	foreach (<CACHEFILE>) {
		chomp;
		# get first character
		my $first_char = substr($_,0,1);
		push(@{$suggestion_hash{$dbname}{$first_char}},$_);
	}
	close(CACHEFILE);
	#_writeLog(Dumper(\%suggestion_hash));
	
	# Populate the temp file storing as hash
	open (TEMPFILE,"> $tempfile");
	print TEMPFILE Dumper(\%suggestion_hash);
	close(TEMPFILE);
	
	$first_char = substr($fldValue,0,1);
	my @sarray = @{$suggestion_hash{$dbname}{$first_char}};
	my $index=1;
	foreach (@sarray) {
		if ($index==1) {
			$string2 = $_;
		}else{
			$string2 .= "::".$_;
		}
		$index++;
	}
}
print $string2;
#_writeLog("\$string2 is $string2\n");


sub _convertNames {

    my ($QueryVar,$DBtable) = @_ ;

    # Special case 1: CELLID changed to CELLNAME.

    $QueryVar = 'CELLNAME' if($QueryVar =~ /CELLID/);

    # Special case 2: ADJPOINTID changed to SIGPOINTID.
    #                 Table name S7SPNT changed to H_SPNT.
    # Needed to match SS-7 Signalling Point counter browser
    # in NPR3.0.

    if($QueryVar =~ /ADJPOINTID/) {
    	$QueryVar = 'SIGPOINTID';
    	$DBtable = "H_SPNT";
    }

    # Special case 3: TRAFFTYPE changed to TTYPENAME.

    $QueryVar = 'TTYPENAME' if($QueryVar =~ /TRAFFTYPE/);

    # Special case 4: SSID changed to SSNAME.

    $QueryVar = 'SSNAME' if($QueryVar =~ /^SSID/);

    # Special case 5: CELL_HDO changed to H_CELL.

    $DBtable = 'H_CELL' if($DBtable =~ /CELL_HDO/);

    # Special case 6: <char>TBDESCRIPT changed to TBDESCRIPT
    if( index( $QueryVar, 'TBDESCRIPT' ) != -1 ) {
        $QueryVar = 'TBDESCRIPT' ;
    }
		return ($QueryVar,$DBtable) ;
}

##################################################################################
#
# Function    : _writeLog
# Parameters  :
# Description :
# Returns     :
# Called By   :
#
##################################################################################
sub _writeLog {
  my ($tolog) = @_ ;
  
  # enable the log level
  if ($ENV{'NPRWEB_NPR_LOGLEVEL'} < 4) {
        return;
  }
  
  my $starttime = localtime();

  my $logfile = $ENV{'NPRWEB_NPR_LOGFILE'};
  open (FILE,">> $logfile");;
  print FILE "[$starttime] $tolog\n";
  close(FILE);

  return; 
};
