/*
# ************************************************************
# @(#) web/webserver/javascript/elementsuggestion.js web_r3.6.2.3.1:cset.001111:22:33@(#)
#
#   Filename    : web/webserver/javascript/elementsuggestion.js
#
# *************************************************************
#
#                   COPYRIGHT NOTICE
#
# This file remains the intellectual property of:
#
#                       Vallent
#                    Spencer House
#                    23 Sheen Road
#                 Richmond, Surrey, UK
#
# Copyright (c) 2005 Vallent Software Systems UK. All rights reserved.
#
# **************************************************************
#
#   Description :
#
# ************************************************************
#
*/

var divSuggest;		// element that hold the selection list
var divSuggest;
var fldid;				
var my_div;
var myDiv;
var maxSuggest;
var suggestions = new Array();

function createSuggList() {
    divSuggest = document.createElement( 'div' );
    divSuggest.id = "suggestDiv";
    divSuggest.style.position   = "absolute";
    divSuggest.style.visibility = "hidden";
    
    // attach to document
    document.body.appendChild( divSuggest );
    
    // place the selection list before the calling field
    var parentDiv = my_div.parentNode;
    parentDiv.insertBefore(divSuggest, my_div);
}

function setField() {
	var Optarray = document.getElementById("elementSelect").options;
	var selection = document.getElementById("elementSelect").selectedIndex;
	
	document.getElementById(fldid).value=Optarray[selection].text;
	
	var d = document.getElementById('suggestDiv');
	var parentDiv = my_div.parentNode;
	parentDiv.removeChild(d);
	
	document.getElementById(fldid).focus();
}

function createOptions(selectElement,arrList) {
	var opt;
	var optindex=0;
	var maxOpt = arrList.length;
	
	if (arrList.length > maxSuggest) {
		maxOpt = maxSuggest;
	}

	for (opt=0; opt<maxOpt; opt++) {
		divSuggest.style.visibility = "visible";
		var optlist=document.createElement('option');
		optlist.text=arrList[opt];
		
		try {
			selectElement.add(optlist,null);
		}catch(e){
			selectElement.add(optlist);			// enable it for IE
		}
	}
	
	// display up to 5 item
	if (selectElement.options.length < 4) {
		selectElement.size=opt;
	}else{
		selectElement.size=3;
	}
		
	if (selectElement.options.length == 0) {
		divSuggest.style.visibility = "hidden";
	}
}

// FUNCTION : getXmlHttp()
//		To initiate the getXmlHttp
function getXmlHttp() {
	var xmlHttp;
	try
	{
		// Firefox, Opera 8.0+, Safari
		xmlHttp=new XMLHttpRequest();
	}
	catch (e)
	{
		// Internet Explorer
		try
		{
			xmlHttp=new ActiveXObject("Msxml2.XMLHTTP");
		}
		catch (e)
		{
			try
			{
				xmlHttp=new ActiveXObject("Microsoft.XMLHTTP");
			}
			catch (e)
			{
				alert("Your browser does not support AJAX!");
				return false;
			}
		}
	}
	
	return xmlHttp;
}

function createSelect(optArray,instr) {
	// Sort the filtered
	optArray.sort();	
	
	// create a section to put options list for the suggestion
	if (document.getElementById('suggestDiv') == null) {
		createSuggList();
	}
	
	// if we type something and have suggested element(s), the display it
	if ( instr.length>0 ) {
		// create the select element
		divSuggest.innerHTML  = "<select id='elementSelect' onclick='setField();' style='z-index:5'></select>";
		
		var selectElement = document.getElementById("elementSelect");
		//document.getElementById("RM").style.visibility = "hidden";
		
		// create suggestions as option
		createOptions(selectElement,optArray);
	}else{
		var d = document.getElementById('suggestDiv');
		
		var parentDiv = my_div.parentNode;
		parentDiv.removeChild(d);
	}
}

// FUNCTION : getSuggestion()
//		This will process the string in the field and come out with suggestion
function getSuggestion(instr) {
	var optArray = new Array();	// array for filtered elements
	var j=0;
	
	var instrArray = new Array();
	instrArray = instr.split('');
	
	// try to filter the suggestion based on whatever entered to the field
	//	initially suggestions.length will be
	for (var i=0;i < suggestions.length; ++i)	{
		var subSuggest = suggestions[i].substring(0,instr.length).toUpperCase();
		var subPatt = instr.toUpperCase();
		
		// Filter out element from suggestions array
		if (subSuggest.match(subPatt) && j<10) {
			optArray[j++] = suggestions[i];
		}
	}
	
	// If we only have single character, then let Perl generate the list of element from cache file
	if (instr.length==1) {
		// get the first character, as Perl will give everything starts with it
		var strFirstChar = new Array();
		strFirstChar = instr.split('');
		
		var xmlHttp = getXmlHttp();
		xmlHttp.onreadystatechange=function()
		{
			if(xmlHttp.readyState==4)
			{
				// get the response from server.
				var optResponse = xmlHttp.responseText;
				optArray = optResponse.split("::");
				
				// copy the array to suggestions, so that later we can just use javascript to get suggestion
				suggestions = optArray;
				
				if (optArray.length > 1) {
					createSelect(optArray,instr);
				}
			}
		}
		
		xmlHttp.open("GET","../cgi/ElementSuggestion.pl?TECHLAYER="+techlayer+"&NPRSYS="+nprsys+"&FIELDVALUE="+strFirstChar[0]+"&IDCALL="+myDiv.getAttribute( "dbItem" ),true);
		xmlHttp.send(null);
	} else {
		createSelect(optArray,instr);
	}
}

function doSuggestion (object) {	
	// do nothing if user press 'Shift', 'Ctrl', 'Alt', 'Arrow Left', 'Arrow Up', 'Arrow Right' and 'Arrow Down'
	var KeyID = event.keyCode;
	if (KeyID==16 || KeyID==17 || KeyID==18 || KeyID==37 || KeyID==38 || KeyID==39 || KeyID==40) {
		return;
	}
	
	fldid = object.getAttribute( "id" );						// This is the field id we currently working
	techlayer = object.getAttribute( "techlayer" );
	nprsys = object.getAttribute( "nprsys" );
	maxSuggest = object.getAttribute( "maxSuggest" );
	
	my_div = document.getElementById(object.id+'Div');			// This is the 'div' that will be base for suggestion list
	myDiv = document.getElementById(fldid);
	
	getSuggestion(object.value);
}